crafting = {}
crafting.internal = {}
crafting.internal.recipes = {}
crafting.internal.learnt = {}

function crafting.displayRecipes(id)
	local craftrecipes = {}
	if crafting.internal.learnt[player(id,"usgn")] then
		for _,recipe in pairs(crafting.internal.learnt[player(id,"usgn")]) do
			craftrecipes[#craftrecipes+1] = {}
			craftrecipes[#craftrecipes][1] = ""
			for __,i in pairs(recipe[1]) do
				craftrecipes[#craftrecipes][1]=craftrecipes[#craftrecipes][1]..i[2].." of "..items[i[1]][1]
				if __<#recipe[1] then
					craftrecipes[#craftrecipes][1]=craftrecipes[#craftrecipes][1].." and "
				end
			end
			craftrecipes[#craftrecipes][1]=craftrecipes[#craftrecipes][1].." from "
			for __,i in pairs(recipe[2]) do
				craftrecipes[#craftrecipes][1]=craftrecipes[#craftrecipes][1]..i[2].." of "..items[i[1]][1]
				if __<#recipe[2] then
					craftrecipes[#craftrecipes][1]=craftrecipes[#craftrecipes][1].." and "
				end
			end
			craftrecipes[#craftrecipes][2] = ""
			craftrecipes[#craftrecipes][3] = crafting.internal.craft
			craftrecipes[#craftrecipes][4] = _
		end
	end
	for _,recipe in pairs(crafting.internal.recipes) do
		if recipe[3] then
			craftrecipes[#craftrecipes+1] = {}
			craftrecipes[#craftrecipes][1] = ""
			for __,i in pairs(recipe[1]) do
				craftrecipes[#craftrecipes][1]=craftrecipes[#craftrecipes][1]..i[2].." of "..items[i[1]][1]
				if __<#recipe[1] then
					craftrecipes[#craftrecipes][1]=craftrecipes[#craftrecipes][1].." and "
				end
			end
			craftrecipes[#craftrecipes][1]=craftrecipes[#craftrecipes][1].." from "
			for __,i in pairs(recipe[2]) do
				craftrecipes[#craftrecipes][1]=craftrecipes[#craftrecipes][1]..i[2].." of "..items[i[1]][1]
				if __<#recipe[2] then
					craftrecipes[#craftrecipes][1]=craftrecipes[#craftrecipes][1].." and "
				end
			end
			craftrecipes[#craftrecipes][2] = ""
			craftrecipes[#craftrecipes][3] = crafting.internal.craft
			craftrecipes[#craftrecipes][4] = _
		end
	end
	for _,recipe in pairs(crafting.internal.recipes) do
		if (crafting.internal.learnt[player(id,"usgn")] and not crafting.internal.learnt[player(id,"usgn")][_]) or not recipe[3] then
			if crafting.displayunlearnt then
				craftrecipes[#craftrecipes+1] = {}
				craftrecipes[#craftrecipes][1] = "("
				for __,i in pairs(recipe[1]) do
					craftrecipes[#craftrecipes][1]=craftrecipes[#craftrecipes][1]..i[2].." of "..items[i[1]][1]
					if __<#recipe[1] then
						craftrecipes[#craftrecipes][1]=craftrecipes[#craftrecipes][1].." and "
					end
				end
				craftrecipes[#craftrecipes][1]=craftrecipes[#craftrecipes][1].." from "
				for __,i in pairs(recipe[2]) do
					craftrecipes[#craftrecipes][1]=craftrecipes[#craftrecipes][1]..i[2].." of "..items[i[1]][1]
					if __<#recipe[2] then
						craftrecipes[#craftrecipes][1]=craftrecipes[#craftrecipes][1].." and "
					end
				end
				craftrecipes[#craftrecipes][1] = craftrecipes[#craftrecipes][1]..")"
				craftrecipes[#craftrecipes][2] = ""
				craftrecipes[#craftrecipes][3] = crafting.internal.craft
				craftrecipes[#craftrecipes][4] = _
			end
		end
	end
	unimenu(id,true,{title="Crafting",items=craftrecipes},1)
end

function crafting.createRecipe(results,ingredients,learnable,successchance)
	successchance = successchance or crafting.successchance
	crafting.internal.recipes[#crafting.internal.recipes+1] = {results,ingredients,learnable,successchance}
	return #crafting.internal.recipes
end

function crafting.learnRecipe(id,recipe)
	if not crafting.internal.learnt[player(id,"usgn")] then crafting.internal.learnt[player(id,"usgn")]={} end
	crafting.internal.learnt[player(id,"usgn")][recipe]=true
end

function crafting.craft(id,recipe)
	if type(recipe)=="number" then recipe = crafting.internal.recipes[recipe] end
	if (crafting.internal.learnt[player(id,"usgn")] and crafting.internal.learnt[player(id,"usgn")][recipe]) or recipe[3] then
		local ingredientsused
		for _,i in pairs(recipe[2]) do
			ingredientsused = items.removeItem(id,i[1],i[2])
			if not ingredientsused then break end
		end
		if not ingredientsused then
			msg2(id,"Not enough ingredients.")
			return
		end
		local randchance = math.random(1,100)
		if randchance>100-recipe[4] then
			local resultproduced
			for _,r in pairs(recipe[1]) do
				resultproduced = items.addToInventory(id,r[1],r[2])
				if not resultproduced then break end
			end
			if not resultproduced then
				msg2(id,"Cannot produce result - inventory full.")
				return
			end
			msg2(id,"Succesfully crafted!")
		else
			msg2(id,"You couldn't quite do it.")
		end
	else
		msg2(id,"You don't know how to do that yet!")
	end
end

function crafting.internal.craft(id,slot)
	crafting.craft(id,slot[4])
end